function love.load()
	width, height = love.graphics.getDimensions( )
	triangle = {
		{x=math.random(width), y=math.random(height)},
		{x=math.random(width), y=math.random(height)},
		{x=math.random(width), y=math.random(height)},
	}
	inside = false
	n_point = 1
end

--function is_point_in_triangle(p, t) -- 0.090537000040058
--	local a = {
--		 t[2].x*t[3].y,
--		-t[2].y*t[3].x,
--		 t[1].x*( t[2].y-t[3].y),
--		 t[1].y*(-t[2].x+t[3].x)
--	}
--	local b = {
--		 t[1].x*t[2].y,
--		-t[1].y*t[2].x,
--		p.x*(t[1].y-t[2].y),
--		p.y*(t[2].x-t[1].x)
--	}
--	local c = {
--		 t[1].y*t[3].x,
--		-t[1].x*t[3].y,
--		 p.x*(t[3].y-t[1].y),
--		 p.y*(t[1].x-t[3].x)
--	}
--	local sa = a[1]+a[2]+a[3]+a[4]
--	local sb = b[1]+b[2]+b[3]+b[4]
--	local sc = c[1]+c[2]+c[3]+c[4]
--	local sign = (sa>=0) and 1 or -1
--	if (sign*sb>0) and (sign*sc>0) and (sb+sc)<(sign*sa) then
--		return true
--	else
--		return false
--	end
--end

function is_point_in_triangle(p, t) -- 0.023362800013274
  local px, py, x1, y1, x2, y2, x3, y3 = p.x, p.y, t[1].x, t[1].y, t[2].x, t[2].y, t[3].x, t[3].y
  local ax, ay = x1 - px, y1 - py
  local bx, by = x2 - px, y2 - py
  local cx, cy = x3 - px, y3 - py
  local sab = ax*by - ay*bx < 0
  if sab ~= (bx*cy - by*cx < 0) then
    return false
  end
  return sab == (cx*ay - cy*ax < 0)
end

function love.update(dt)
	local point={x=love.mouse.getX( ),y=love.mouse.getY( )}
	inside = is_point_in_triangle(point, triangle)

--	local time = love.timer.getTime( )
--	for i = 1, 1000000 do
--		local point={x=math.random(width), y=math.random(height)}
--		local inside = is_point_in_triangle(point, triangle)
--	end
--	print(love.timer.getTime( )-time)
end



function draw_triangle(t) 
--	love.graphics.line(t[1].x,t[1].y,t[2].x,t[2].y,t[3].x,t[3].y,t[1].x,t[1].y)
	love.graphics.line(t[1].x,t[1].y,t[2].x,t[2].y)
	love.graphics.line(t[2].x,t[2].y,t[3].x,t[3].y)
	love.graphics.line(t[3].x,t[3].y,t[1].x,t[1].y)
end

function love.draw()
	if inside then
		love.graphics.setColor(0,1,0)
	else
		love.graphics.setColor(1,0,0)
	end
	
	draw_triangle(triangle)
end

function love.mousereleased(x, y, button)
	if button == 1 then
		triangle[n_point].x=x
		triangle[n_point].y=y
		n_point=(n_point)%3+1 -- 1, 2 or 3
	end
end